=== debian/changelog ===
udunits (2.2.28-8) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.2; no changes required
  * Update d/watch file
  * Add shlibs:Depends, misc:Depends to udunits-bin for debhelper
  * Move recommends: pkgs-config -> pkgconf
  * Re-create html files to allow multiple builds. Closes: #1049582
  * Close old bugs: Closes: #1013822, #1013858
  * Mark linudunits-0 as Multi-Arch: same
  * Update d/copyright. Closes: #837666

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Aug 2025 08:55:24 +0100

udunits (2.2.28-7) unstable; urgency=medium

  * Delete autogenerated files for multiple-successive builds.
    Closes: #1046458, #1049582
  * Standards-Version: 4.6.2
  * Ack previously closed bugs. Closes: #1013858, #1013822
  * Fix watch file to use https page

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 18 Aug 2023 13:24:17 +0100

udunits (2.2.28-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + libudunits2-0: Drop versioned constraint on dpkg and install-info in
      Depends.
    + libudunits2-data: Drop versioned constraint on libudunits2-0 in Replaces.
    + libudunits2-data: Drop versioned constraint on libudunits2-0 in Breaks.
    + udunits-bin: Drop versioned constraint on dpkg and install-info in
      Depends.
    + udunits-bin: Drop versioned constraint on libudunits2-0 in Replaces.
    + udunits-bin: Drop versioned constraint on libudunits2-0 in Breaks.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 31 Jan 2023 11:47:17 +0000

udunits (2.2.28-5) unstable; urgency=medium

  * Drop dep on install-info. Closes: #1013858, #1013822
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 27 Jun 2022 13:07:02 +0100

udunits (2.2.28-4) unstable; urgency=medium

  * Don't ship broken redundant symlinks in doc dirs. Closes: #986457
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 23 Apr 2022 12:53:28 +0100

udunits (2.2.28-3) unstable; urgency=medium

  * add initial autopkg test(s)
  * Fix for buggy XML data path calculation. Closes: #981289

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 29 Jan 2021 11:20:01 +0000

udunits (2.2.28-2) unstable; urgency=medium

  * Fix regression; xml files ship in -data. Closes: #978397

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 27 Dec 2020 08:54:54 +0000

udunits (2.2.28-1) unstable; urgency=medium

  * New upstream release
  * Now use debhelper-compat (= 13)
  * Standards-Version: 4.5.1; no changes required
  * Move to DEP-14 branches; point vcs-git to debian/latest
  * Add d/gbp.conf to document branches
  * Update docs: add DOI, README, remove BACK_LOG
  * Drop M-A: same from libudunits2-0 and dev pkg Closes: #874234
  * Drop hard-coded xz compression

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Dec 2020 12:49:02 +0000
