=== debian/control ===
Source: udunits
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13), 
 libexpat-dev, 
 libcunit1-dev, 
 texinfo, 
 libtool, 
 texlive 
Standards-Version: 4.7.2
Homepage: https://www.unidata.ucar.edu/software/udunits/
Vcs-Browser: https://salsa.debian.org/science-team/udunits.git
Vcs-Git: https://salsa.debian.org/science-team/udunits.git -b  debian/latest

Package: libudunits2-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: libudunits2-data, ${misc:Depends}, ${shlibs:Depends}
Description: Library for handling of units of physical quantities
 The UDUNITS package supports units of physical quantities (e.g., meters, 
 seconds).  Specifically, it supports conversion between string and binary 
 representations of units, arithmetic manipulation of units, and conversion of 
 numeric values between compatible units. The package is written in the 
 C programming language.

Package: libudunits2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data for handling of units of physical quantities
 The UDUNITS package supports units of physical quantities (e.g., meters, 
 seconds).  Specifically, it supports conversion between string and binary 
 representations of units, arithmetic manipulation of units, and conversion of 
 numeric values between compatible units. The package is written in the 
 C programming language.
 .
 This package provides the data files used by the library.

Package: libudunits2-dev
Section: libdevel
Architecture: any
Depends: libudunits2-0 ( = ${binary:Version}), ${misc:Depends}
Recommends: pkgconf
Description: Development files for the libunits physical units package
 The UDUNITS package supports units of physical quantities (e.g., meters, 
 seconds).  Specifically, it supports conversion between string and binary 
 representations of units, arithmetic manipulation of units, and conversion of 
 numeric values between compatible units. The package is written in the 
 C programming language.
 .
 This package provides the include files and static libraries for development.

Package: udunits-bin
Section: utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libudunits2-0 (<= 2.2.26-2)
Description: Utility for handling units of physical quantities
 udunits is a utility  for handling units of physical quantities. It supports 
 conversion between string and binary representations of units,
 arithmetic manipulation of units, and conversion of numeric values between 
 compatible units. The package is written in the C programming language.
