=== debian/tests/control ===
Test-Command: set -e
  ; udunits2 -H cm -W inch 2> /dev/null
Depends: udunits-bin
Superficial: yes
