=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=4
opts="searchmode=plain" \
  https://docs.unidata.ucar.edu/udunits/current/index.html \
  https://downloads.unidata.ucar.edu/udunits/.*/udunits-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
